--disable_warnings
drop table if exists t1,t2,t3;
--enable_warnings
SET SQL_WARNINGS=1;

#
# This failed for Elizabeth Mattijsen
#

eval CREATE TABLE t1 (
  ID CHAR(32) NOT NULL,
  name CHAR(32) NOT NULL,
  value CHAR(255),
  INDEX indexIDname (ID(8),name(8))
)  ENGINE = $engine_type;

INSERT INTO t1 VALUES
('keyword','indexdir','/export/home/local/www/database/indexes/keyword');
INSERT INTO t1 VALUES ('keyword','urlprefix','text/ /text');
INSERT INTO t1 VALUES ('keyword','urlmap','/text/ /');
INSERT INTO t1 VALUES ('keyword','attr','personal employee company');
INSERT INTO t1 VALUES
('emailgids','indexdir','/export/home/local/www/database/indexes/emailgids');
INSERT INTO t1 VALUES ('emailgids','urlprefix','text/ /text');
INSERT INTO t1 VALUES ('emailgids','urlmap','/text/ /');
INSERT INTO t1 VALUES ('emailgids','attr','personal employee company');

SELECT value FROM t1 WHERE ID='emailgids' AND name='attr';

drop table t1;

#
# Problem with many key parts and many or
#

eval CREATE TABLE t1 (
  price int(5) DEFAULT '0' NOT NULL,
  area varchar(40) DEFAULT '' NOT NULL,
  type varchar(40) DEFAULT '' NOT NULL,
  transityes enum('Y','N') DEFAULT 'Y' NOT NULL,
  shopsyes enum('Y','N') DEFAULT 'Y' NOT NULL,
  schoolsyes enum('Y','N') DEFAULT 'Y' NOT NULL,
  petsyes enum('Y','N') DEFAULT 'Y' NOT NULL,
  KEY price (price,area,type,transityes,shopsyes,schoolsyes,petsyes)
) ENGINE = $engine_type;

INSERT INTO t1 VALUES (900,'Vancouver','Shared/Roomate','N','N','N','N');
INSERT INTO t1 VALUES (900,'Vancouver','Shared/Roomate','N','N','N','N');
INSERT INTO t1 VALUES (900,'Vancouver','Shared/Roomate','','','','');
INSERT INTO t1 VALUES (900,'Vancouver','Shared/Roomate','Y','Y','Y','Y');
INSERT INTO t1 VALUES (900,'Vancouver','Shared/Roomate','Y','Y','Y','Y');
INSERT INTO t1 VALUES (900,'Vancouver','Shared/Roomate','Y','Y','Y','Y');
INSERT INTO t1 VALUES (900,'Vancouver','Shared/Roomate','Y','Y','Y','Y');
INSERT INTO t1 VALUES (900,'Vancouver','Shared/Roomate','Y','Y','Y','Y');

 SELECT * FROM t1 WHERE area='Vancouver' and transityes='y' and schoolsyes='y' and ( ((type='1 Bedroom' or type='Studio/Bach') and (price<=500)) or ((type='2 Bedroom') and (price<=550)) or ((type='Shared/Roomate') and (price<=300)) or ((type='Room and Board') and (price<=500)) ) and price <= 400;

drop table t1;

#
# No longer a problem with primary key
#

eval CREATE TABLE t1 (program enum('signup','unique','sliding') not null,  type enum('basic','sliding','signup'),  sites set('mt'),  PRIMARY KEY (program)) ENGINE = $engine_type;
# This no longer give an error for wrong primary key
ALTER TABLE t1 modify program enum('signup','unique','sliding');
drop table t1;

#
# Test of compressed decimal index.
#

eval CREATE TABLE t1 (
  name varchar(50) DEFAULT '' NOT NULL,
  author varchar(50) DEFAULT '' NOT NULL,
  category decimal(10,0) DEFAULT '0' NOT NULL,
  email varchar(50),
  password varchar(50),
  proxy varchar(50),
  bitmap varchar(20),
  msg varchar(255),
  urlscol varchar(127),
  urlhttp varchar(127),
  timeout decimal(10,0),
  nbcnx decimal(10,0),
  creation decimal(10,0),
  livinguntil decimal(10,0),
  lang decimal(10,0),
  type decimal(10,0),
  subcat decimal(10,0),
  subtype decimal(10,0),
  reg char(1),
  scs varchar(255),
  capacity decimal(10,0),
  userISP varchar(50),
  CCident varchar(50) DEFAULT '' NOT NULL,
  PRIMARY KEY (name,author,category)
) ENGINE = $engine_type;
INSERT INTO t1 VALUES
('patnom','patauteur',0,'p.favre@cryo-networks.fr',NULL,NULL,'#p2sndnq6ae5g1u6t','essai salut','scol://195.242.78.119:patauteur.patnom',NULL,NULL,NULL,950036174,-882087474,NULL,3,0,3,'1','Pub/patnom/futur_divers.scs',NULL,'pat','CC1');
INSERT INTO t1 VALUES
('LeNomDeMonSite','Marc',0,'m.barilley@cryo-networks.fr',NULL,NULL,NULL,NULL,'scol://195.242.78.119:Marc.LeNomDeMonSite',NULL,NULL,NULL,950560434,-881563214,NULL,3,0,3,'1','Pub/LeNomDeMonSite/domus_hibere.scs',NULL,'Marq','CC1');
select * from t1 where name='patnom' and author='patauteur' and category=0;
drop table t1;

#
# Problem with search on partial index
#


#
# Test bug with long primary key
#

eval create table t1
(
   SEQNO                         numeric(12 ) not null,
   MOTYPEID                 numeric(12 ) not null,
   MOINSTANCEID     numeric(12 ) not null,
   ATTRID                       numeric(12 ) not null,
   VALUE                         varchar(120) not null,
   primary key (SEQNO, MOTYPEID, MOINSTANCEID, ATTRID, VALUE )
) ENGINE = $engine_type;
INSERT INTO t1 VALUES (1, 1, 1, 1, 'a'); 
INSERT INTO t1 VALUES (1, 1, 1, 1, 'b'); 
--error 1062
INSERT INTO t1 VALUES (1, 1, 1, 1, 'a');
drop table t1;

#
# Test with blob + tinyint key
# (Failed for Greg Valure)
#


#
# Test of create key order
#

eval create table t1 (a int not null unique, b int unique, c int, d int not null primary key, key(c), e int not null unique) ENGINE = $engine_type;
show keys from t1;
drop table t1;

#
# Problem with UNIQUE() with NULL parts and auto increment
#


#
# longer keys
#

#
# Test of key read with primary key (Bug #3497)
#

eval CREATE TABLE t1 (id int unsigned auto_increment, name char(50), primary key (id))  ENGINE = $engine_type;
insert into t1 (name) values ('a'), ('b'),('c'),('d'),('e'),('f'),('g');
explain select 1 from t1 where id =2;
explain select 1 from t1 where id =2 or id=3;
explain select name from t1 where id =2;
ALTER TABLE t1 DROP PRIMARY KEY, ADD INDEX (id);
explain select 1 from t1 where id =2;
drop table t1;

#
# Test of problem with key read (Bug #3666)
#

eval CREATE TABLE t1 (numeropost mediumint(8) unsigned NOT NULL default '0', numreponse int(10) unsigned NOT NULL auto_increment, PRIMARY KEY (numeropost,numreponse), UNIQUE KEY numreponse (numreponse)) ENGINE = $engine_type;
INSERT INTO t1 (numeropost,numreponse) VALUES ('1','1'),('1','2'),('2','3'),('2','4');
SELECT numeropost FROM t1 WHERE numreponse='1';
EXPLAIN SELECT numeropost FROM t1 WHERE numreponse='1';
FLUSH TABLES;
SELECT numeropost FROM t1 WHERE numreponse='1';
drop table t1;

#
# UNIQUE prefix keys and multi-byte charsets
#


#
# BUG#6151 - myisam index corruption
#
DROP TABLE IF EXISTS t1;
eval CREATE TABLE t1 (
  c1 int,
  c2 varbinary(240),
  UNIQUE KEY (c1),
  KEY (c2)
)  ENGINE = $engine_type;
INSERT INTO t1 VALUES (1,'\Z\Z\Z\Z');
INSERT INTO t1 VALUES (2,'\Z\Z\Z\Z\Z\Z');
INSERT INTO t1 VALUES (3,'\Z\Z\Z\Z');
select c1 from t1 where c2='\Z\Z\Z\Z';
DELETE FROM t1 WHERE (c1 = 1);
check table t1;
select c1 from t1 where c2='\Z\Z\Z\Z';
DELETE FROM t1 WHERE (c1 = 3);
check table t1;
select c1 from t1 where c2='\Z\Z\Z\Z';

#
# test delete of keys in a different order
#
truncate table t1;
insert into t1 values(1,"aaaa"),(2,"aaab"),(3,"aaac"),(4,"aaccc");
delete from t1 where c1=3;
delete from t1 where c1=1;
delete from t1 where c1=4;
check table t1;

drop table t1;

#
# Bug 6166: index prefix length of 0 not rejected
#
# this test should fail in 5.0
# to fix it, remove #ifdef in 
# file sql_yacc.yy(key_part)
# create dedicated error code for this and
# and change my_printf_error() to my_error

--error 1391
eval create table t1 (c char(10), index (c(0))) ENGINE = $engine_type;

#
# Bug #6126: Duplicate columns in keys should fail
# Bug #6252: (dup)
#
--error 1060
eval create table t1 (c char(10), index (c,c)) ENGINE = $engine_type;
--error 1060
eval create table t1 (c1 char(10), c2 char(10), index (c1,c2,c1)) ENGINE = $engine_type;
--error 1060
eval create table t1 (c1 char(10), c2 char(10), index (c1,c1,c2)) ENGINE = $engine_type;
--error 1060
eval create table t1 (c1 char(10), c2 char(10), index (c2,c1,c1)) ENGINE = $engine_type;
eval create table t1 (c1 char(10), c2 char(10)) ENGINE = $engine_type;
--error 1060
alter table t1 add key (c1,c1);
--error 1060
alter table t1 add key (c2,c1,c1);
--error 1060
alter table t1 add key (c1,c2,c1);
--error 1060
alter table t1 add key (c1,c1,c2);
drop table t1;

#
# Bug#11228: DESC shows arbitrary column as "PRI"
#
eval create table t1 (
 i1 INT NOT NULL,
 i2 INT NOT NULL,
 UNIQUE i1idx (i1),
 UNIQUE i2idx (i2)) ENGINE = $engine_type;
desc t1;
show create table t1;
drop table t1;

#
# Bug#12565 - ERROR 1034 when running simple UPDATE or DELETE 
#             on large MyISAM table
#
eval create table t1 (
  c1 int,
  c2 varchar(20) not null,
  primary key (c1),
  key (c2(10))
)  ENGINE = $engine_type;
insert into t1 values (1,'');
insert into t1 values (2,' \t\tTest String');
insert into t1 values (3,' \n\tTest String');
update t1 set c2 = 'New Test String' where c1 = 1;
select * from t1;
drop table t1;

#
# If we use a partial field for a key that is actually the length of the
# field, and we extend the field, we end up with a key that includes the
# whole new length of the field.
#
eval create table t1 (a varchar(10), b varchar(10), key(a(10),b(10))) ENGINE = $engine_type;
show create table t1;
alter table t1 modify b varchar(20);
show create table t1;
alter table t1 modify a varchar(20);
show create table t1;
drop table t1;

#
# Bug #11227: Incorrectly reporting 'MUL' vs. 'UNI' on varchar
#
eval create table t1 (a int not null primary key, b varchar(20) not null unique) ENGINE = $engine_type;
desc t1;
drop table t1;
eval create table t1 (a int not null primary key, b int not null unique) ENGINE = $engine_type;
desc t1;
drop table t1;
eval create table t1 (a int not null primary key, b varchar(20) not null, unique (b(10))) ENGINE = $engine_type;
desc t1;
drop table t1;
eval create table t1 (a int not null primary key, b varchar(20) not null, c varchar(20) not null, unique(b(10),c(10))) ENGINE = $engine_type;
desc t1;
drop table t1;

# End of 4.1 tests

#
# Bug #24778: Innodb: No result when using ORDER BY
#
eval CREATE TABLE t1 (
  a INTEGER auto_increment PRIMARY KEY,
  b INTEGER NOT NULL,
  c INTEGER NOT NULL,
  d CHAR(64)
) ENGINE = $engine_type;

eval CREATE TABLE t2 (
  a INTEGER auto_increment PRIMARY KEY,
  b INTEGER NOT NULL,
  c SMALLINT NOT NULL,
  d DATETIME NOT NULL,
  e SMALLINT NOT NULL,
  f INTEGER NOT NULL,
  g INTEGER NOT NULL,  
  h SMALLINT NOT NULL,
  i INTEGER NOT NULL,
  j INTEGER NOT NULL,
  UNIQUE INDEX (b),
  INDEX (b, d, e, f, g, h, i, j, c),
  INDEX (c)
) ENGINE = $engine_type;

INSERT INTO t2 VALUES 
  (NULL, 1, 254, '1000-01-01 00:00:00', 257, 0, 0, 0, 0, 0),
  (NULL, 2, 1, '2004-11-30 12:00:00', 1, 0, 0, 0, 0, 0),
  (NULL, 3, 1, '2004-11-30 12:00:00', 1, 0, 0, 2, -21600, 0),
  (NULL, 4, 1, '2004-11-30 12:00:00', 1, 0, 0, 2, -10800, 0),
  (NULL, 5, 1, '2004-11-30 12:00:00', 1, 0, 0, 5, -10800, 0),
  (NULL, 6, 1, '2004-11-30 12:00:00', 102, 0, 0, 0, 0, 0),
  (NULL, 7, 1, '2004-11-30 12:00:00', 105, 2, 0, 0, 0, 0),
  (NULL, 8, 1, '2004-11-30 12:00:00', 105, 10, 0, 0, 0, 0);

INSERT INTO t1 (b, c, d) VALUES
  (3388000, -553000, NULL),
  (3388000, -553000, NULL);

SELECT *
FROM t2 c JOIN t1 pa ON c.b = pa.a 
WHERE c.c = 1
ORDER BY c.b, c.d
;

DROP TABLE t1, t2;


#
# Bug #20604: Test for disabled keys with aggregate functions and FORCE INDEX.
#
eval CREATE TABLE t1( a TINYINT, KEY(a) )  ENGINE = $engine_type;
INSERT INTO t1 VALUES( 1 );
ALTER TABLE t1 DISABLE KEYS;
EXPLAIN SELECT MAX(a) FROM t1 FORCE INDEX(a);
DROP TABLE t1;

--echo End of 5.0 tests.
